/*
 *   swdesk.c -- switch desk/page from command line
 *
 *   ATTENSION: You should apply patch to fvwm.
 *   
 *   This is written by Yoshikazu Yamamoto <y-yamamt@ics.es.osaka-u.ac.jp>,
 *   and modified by MAKOTO Matsushita <matusita@ics.es.osaka-u.ac.jp>.
 *
 *   Created: Nov/10/94, Last modified: Nov/20/94
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

main(argc, argv)
int	argc;
char	**argv;
{
    Display			*dpy;
    Window			root;
    Atom			_XA_WM_DESKTOP;
    Atom			_XA_WM_PAGE;
    unsigned long		data[2];
    char			*prog;
    int				act_as_swpage;

    if ((prog = rindex(*argv, '/')) == NULL)
	prog = *argv;
    else
	prog++;

    /* Am I swpage ? */
    if((strcmp(prog, "swpage") == 0) || (argc == 3))
	act_as_swpage++;

    /* argment check */
    if (act_as_swpage && (argc != 3)) {
	fprintf(stderr, "usage: %s new_viewport_x new_viewport_y\n", prog);
	exit(1);
    }
    if((argc == 1) || (argc > 3) ||
       ((argv[0] != NULL) && (strncmp(argv[0], "-h", 2) == 0))) {
	fprintf(stderr, "usage: %s new_desk_number\n", prog);
	fprintf(stderr, "       %s new_viewport_x new_viewport_y\n", prog);
	exit(1);
    }

    /* setting Property */
    if ((dpy = XOpenDisplay(NULL)) == NULL) {
	fprintf(stderr, "%s: cannot open display\n", prog);
	exit(1);
    }
    root = DefaultRootWindow(dpy);
    if(act_as_swpage) {
	_XA_WM_PAGE = XInternAtom(dpy, "WM_PAGE", False);
	data[0] = (unsigned long) atol(argv[1]);
	data[1] = (unsigned long) atol(argv[2]);
	XChangeProperty(dpy, root, _XA_WM_PAGE, _XA_WM_PAGE, 32,
			PropModeReplace, (unsigned char *) data, 2);
    } else {
	_XA_WM_DESKTOP = XInternAtom(dpy, "WM_DESKTOP", False);
	data[0] = (unsigned long) atol(argv[1]);
	XChangeProperty(dpy, root, _XA_WM_DESKTOP, _XA_WM_DESKTOP, 32,
			PropModeReplace, (unsigned char *) data, 1);
    }
    XFlush(dpy);

    exit(0);
}
