/**********************************************************************
	mwm setting
 **********************************************************************
Mwm*fontList: \
-*-fixed-medium-r-*--16-*-c-*-iso8859-1=ISO8859-1,\
-*-fixed-medium-r-*--16-*-c-*-jisx0201.1976-0=JISX0201.1976-0,\
-*-fixed-medium-r-*--16-*-c-*-jisx0208.1983-0=JISX0208.1983-0,\
-*-medium-r-*--16-*-c-*-gb2312.1980-*=GB2312.1980-0,\
-*-mincho-medium-r-*--16-*-c-*-ksc5601.1987-0=KSC5601.1987-0,\
-*-fixed-medium-r-*--16-*-c-*:
Mwm*icon*fontList: \
-*-fixed-medium-r-*--16-*-c-*-iso8859-1=ISO8859-1,\
-*-fixed-medium-r-*--16-*-c-*-jisx0201.1976-0=JISX0201.1976-0,\
-*-fixed-medium-r-*--16-*-c-*-jisx0208.1983-0=JISX0208.1983-0,\
-*-medium-r-*--16-*-c-*-gb2312.1980-*=GB2312.1980-0,\
-*-mincho-medium-r-*--16-*-c-*-ksc5601.1987-0=KSC5601.1987-0,\
-*-fixed-medium-r-*--16-*-c-*:
***********************************************************************/

/**********************************************************************
	fvwm-i18n setting (note: depending current locale)
 **********************************************************************
WindowFont -adobe-helvetica-bold-r-*--17-*, -*-fixed-medium-r-*--16-*-c-*, -*-mincho-medium-r-*--16-*-c-*, -*-medium-r-*--16-*-c-*
IconFont -adobe-helvetica-medium-r-*--17-*, -*-fixed-medium-r-*--16-*-c-*, -*-mincho-medium-r-*--16-*-c-*, -*-medium-r-*--16-*-c-*
***********************************************************************/

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/Xatom.h>
#include <X11/Xaw/Command.h>
#include <X11/Shell.h>		/* XtNtitle, XtNtitleEncoding */
#include <X11/StringDefs.h>	/* XtNcallback */

static void do_exit(widget, closure, call_data)
	Widget widget;
	XtPointer closure, call_data;
{
	exit(0);
}

main(argc, argv)
  int argc;
  char **argv;
{
  XtAppContext app_context;
  Widget toplevel, command;
  Atom compound_text;
  int test_type = 0;
  char *name;

  toplevel = XtAppInitialize(&app_context, "TestTitle",
			     NULL, 0, &argc, argv, NULL, NULL, 0);
  compound_text =
    XInternAtom(XtDisplay(toplevel), "COMPOUND_TEXT", False);

  if (argc > 1)
    test_type = atoi(argv[1]);
  switch (test_type) {
  case 1:
    name = "jp:\033$(B\072\043\106\174\044\117\033(B(\033)I\272\335\306\301\312\033-A),cn:\033$(A\104\143\072\103\033(B,kr:\033$(C\076\110\063\147\107\117\074\074\077\144\033(B,de:Gr\374\337";
    break;
  case 2:
    name = "jp:\033$)B\272\243\306\374\244\317(\033)I\272\335\306\301\312),cn:\033$)A\304\343\272\303,kr:\033$)C\276\310\263\347\307\317\274\274\277\344,de:\033-AGr\374\337";
    break;
  default:
    /* japanese only */
    name = "jp:\033$(B\072\043\106\174\044\117\033(B(\033)I\272\335\306\301\312\033-A)";
    break;
  }
  XtVaSetValues(toplevel, 
		XtNtitleEncoding, compound_text,
		XtNtitle, name,
		XtNiconNameEncoding, compound_text,
		XtNiconName, name,
		NULL);
  command = XtVaCreateManagedWidget("command", commandWidgetClass,
				    toplevel, 
				    XtNlabel, "..........Please click this botton to exit program..........",
				    NULL);
  				    
  XtAddCallback(command, XtNcallback, do_exit, (XtPointer)NULL);
  XtRealizeWidget(toplevel);
  XtAppMainLoop(app_context);
}
